// BookSell.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Calculate.h"
#include "Member.h"
#include "string.h"
#include "RebateRule.h"
#include "NormalRebateRule.h"
#include "SpecialRebateRule.h"
#include "Shop1PrintFactory.h"
#include "Shop2PrintFactory.h"


int main(int argc, char* argv[])
{
	char	szMemberID[MAX_PATH];
	strcpy(szMemberID,"00000001");
	float fConsumeSum = 120.0;

	CMember		*pMember = new CMember(szMemberID,1000.0,75);
	CRebateRule	*pRebateRule = new CNormalRebateRule;
	pRebateRule->Init("Configfile.txt");

	fConsumeSum = pMember->RebateSumAndCumulatePoint(fConsumeSum,pRebateRule);
	assert(pMember->GetPoint() == 87);
	assert(fConsumeSum == 120.0);
	printf("Point = %d\n",pMember->GetPoint());
	printf("ConsumeSum = %f\n",fConsumeSum);

	delete pRebateRule;
	pRebateRule = new CSpecialRebateRule;
	pRebateRule->Init("Configfile.txt");
	
	fConsumeSum = pMember->RebateSumAndCumulatePoint(300.0,pRebateRule);
	assert(pMember->GetPoint() == 117);
	assert(fConsumeSum == 256.5);
	printf("Point = %d\n",pMember->GetPoint());
	printf("ConsumeSum = %f\n",fConsumeSum);
	
	CPrintFactory*	pPrintFactory = new CShop2PrintFactory;
	
	CPrint *pPrint =  pPrintFactory->CreateScreenPrint();
	bool bRel = pPrint->Print(pMember->GetPoint(),fConsumeSum);
	assert(bRel);

	delete pPrint;
	pPrint = pPrintFactory->CreatePaperPrint();
	bRel = pPrint->Print(pMember->GetPoint(),fConsumeSum);
	assert(bRel);
	delete pPrint;


	delete pMember;
	delete pRebateRule;
	return 0;
}

